;============================================================================
;	ZELDIS ጸpb`
;============================================================================
	ORG	1200h

KEEP_FRAMERATE EQU 0		; 0:VBLANK҂̂ 1:15FPSL[v

RDINF	EQU	0027h
RDDAT	EQU	002Ah
LDERR	EQU	00FEh
NL	EQU	0009h
LDMSG	EQU	013Eh
NAME	EQU	10F1h

WTVRAM	EQU	0C600h		; zVRAM eLXg
WAVRAM	EQU	0CA00h		; zVRAM Agr[g

;
;	ZELDIS{̂[h
;
;;;CALL 09B3h			; e[vւp L[͑҂
	CALL	RDINF
	JP	C, LDERR
	CALL	NL
	LD	DE, LDMSG	; 'LOADING'
	RST	18h
	LD	DE, NAME	; FILENAME
	RST	18h
	CALL	RDDAT
	JP	C, LDERR

;
;	pb`𓖂Ă
;
	LD	A, 0C3h		; zVRAMVRAM][`ւ
	LD	(0A47Ch), A
	LD	HL, WAITLOOP_HOOK
	LD	(0A47Dh), HL

	XOR	A		; EFCg[`
	LD	(0A432h), A
	LD	HL, 0
	LD	(0A433h), A

IF KEEP_FRAMERATE
;
;	8253 JE^ݒ
;
	LD	HL, 0E007h		; 8253 Rg[
	LD	(HL), 01_11_010_0b	; Ch.1, LH, Mode 2
	LD	(HL), 10_01_010_0b	; Ch.2, L,    Mode 2
	LD	L, 02h			; 8255 |[gC
	XOR	A
@@:	OR	(HL)			; VBLNK=L̊ԃ[v
	JP	P, @b
@@:	AND	(HL)			; VBLNK=H̊ԃ[v
	JP	M, @b
	LD	L, 05h			; 8253 Ch.1
	LD	(HL), 262 & 0FFh
	LD	(HL), 262 >> 8
	INC	L			; 8253 Ch.2
	LD	(HL), 0FFh
ENDIF

;
;	ZELDISMZ-700[hŎs
;
	LD	A, 22h
	JP	0A314h

;============================================================================
;	WAIT[ṽtbN[`
;	̍XVt[܂ő҂AzVRAMVRAMɓ]
;============================================================================
WAITLOOP_HOOK:
	;
	;	VBLNK̗҂
	;
	LD	HL, 0E002h	; 8255 |[gC
	XOR	A
@@:	OR	(HL)		; VBLNK=L̊ԃ[v
	JP	P, @b
@@:	AND	(HL)		; VBLNK=H̊ԃ[v
	JP	M, @b

IF KEEP_FRAMERATE
	LD	L, 06h		; 8253 Ch.2
	LD	A, (HL)
	CPL
	CP	3
	JR	C, WAITLOOP_HOOK
	LD	(HL), 0FFh
ENDIF
	; fallthru
;============================================================================
;	zVRAMVRAM]
;	荞݋֎~ԂŌĂԂ
;	SWX^j
;============================================================================
VRAMtransfer:
	DI
	LD	(@7f+1), SP
	LD	HL, WTVRAM
	LD	(@5f+1), HL
	LD	HL, WAVRAM
	LD	(@6f+1), HL
	LD	IX, 0D000h + 10
	LD	IY, 0D800h + 10
	LD	BC, 11
	LD	A, (0D000h)	; ^C~O킹
	LD	A, 91		; (1000/11) = 90.9
				; \  :  uLO
@1:				;  (<=165)  :	(<=63)
	EX	AF, AF'		;'; 4 (4)
@5:	LD	SP, WTVRAM	; 10 (14)
	POP	DE		; 10 (24)
	POP	HL		; 10 (34)
	EXX			;  4 (38)
	POP	AF		; 10 (48)
	POP	BC		; 10 (58)
	POP	DE		; 10 (68)
	POP	HL		; 10 (78)
	DEC	SP		;  6 (84)
	LD	(@5b+1), SP	; 20 (104)
	LD	SP, IX		; 10 (114)
	LD	(IX), L		; 16 (130)  :	 3 ( 3)
	PUSH	DE		;		11 (14)
	PUSH	BC		;		11 (25)
	PUSH	AF		;		11 (36)
	EXX			;		 4 (40)
	PUSH	HL		;		11 (51)
	PUSH	DE		;		11 (62)
	ADD	IX, BC		; 15 (145)

@6:	LD	SP, WAVRAM	; 10 (10)
	POP	DE		; 10 (20)
	POP	HL		; 10 (30)
	EXX			;  4 (34)
	POP	AF		; 10 (44)
	POP	BC		; 10 (54)
	POP	DE		; 10 (64)
	POP	HL		; 10 (74)
	DEC	SP		;  6 (80)
	LD	(@6b+1), SP	; 20 (100)
	LD	SP, IY		; 10 (110)
	LD	(IY), L		; 16 (126)  :	 3 ( 3)
	PUSH	DE		;		11 (14)
	PUSH	BC		;		11 (25)
	PUSH	AF		;		11 (36)
	EXX			;		 4 (40)
	PUSH	HL		;		11 (51)
	PUSH	DE		;		11 (62)
	ADD	IY, BC		; 15 (141)

	EX	AF, AF'		;'; 4 (145)
	DEC	A		;  4 (149)
	JP	NZ, @1b		; 10 (159)

@7:	LD	SP, 0000h
	RET

	END
