;============================================================================
;	ZEPLIS2 ጸpb`
;============================================================================
	ORG	3000h

RDINF	EQU	0027h
RDDAT	EQU	002Ah
LDERR	EQU	00FEh
NL	EQU	0009h
LDMSG	EQU	013Eh
NAME	EQU	10F1h

WTVRAM	EQU	2000h		; zVRAM eLXg

;
;	ZEPLIS2{̂[h
;
;;;CALL 09B3h
	CALL	RDINF
	JP	C, LDERR
	CALL	NL
	LD	DE, LDMSG	; 'LOADING'
	RST	18h
	LD	DE, NAME	; FILENAME
	RST	18h
	CALL	RDDAT
	JP	C, LDERR

;
;	pb`𓖂Ă
;
	LD	HL, PATCHDATA
@3:	LD	E, (HL)
	INC	HL
	LD	D, (HL)		; DE = pb`ăAhX
	LD	A, D
	OR	E
	JR	Z, @1f
	INC	HL
	LD	B, (HL)		; B = f[^̒
	INC	HL
@2:	LD	A, (HL)
	INC	HL
	LD	(DE), A
	INC	DE
	DJNZ	@2b
	JR	@3b
@1:

;
;	zʂ
;
	LD	HL, WTVRAM
	LD	DE, WTVRAM+1
	LD	BC, 1000
	LD	(HL), 0
	LDIR

;
;	ZEPLIS2MZ-700[hŎs
;
;	LD	HL, 0
;	LD	(0CFF0h), HL
	LD	A, 22h
	JP	0A518h

;============================================================================
;	CLStbN[`
;============================================================================
CLS_W:
	LD	D, 25
	LD	HL, WTVRAM
	JP	0A712h

;============================================================================
;	PUT@[`
;============================================================================
PUT_ORIG:
	LD	A, 0D0h
	LD	(0B0ABh), A
	CALL	0B098h
	LD	A, 020h
	LD	(0B0ABh), A
	RET

;============================================================================
;	WAIT[ṽtbN[`
;	̍XVt[܂ő҂AzVRAMVRAMɓ]
;============================================================================
WAIT_W:
	;
	;	VBLNK̗҂
	;
	LD	HL, 0E002h	; 8255 |[gC
	XOR	A
@@:	OR	(HL)		; VBLNK=L̊ԃ[v
	JP	P, @b
@@:	AND	(HL)		; VBLNK=H̊ԃ[v
	JP	M, @b
	; fallthru
;============================================================================
;	zVRAMVRAM]
;	荞݋֎~ԂŌĂԂ
;	SWX^j
;============================================================================
VRAMtransfer:
	DI
	LD	(@7f+1), SP
	LD	IX, WTVRAM		; IX  = zVRAMǂݍ݃AhX
	EXX
	LD	HL, 0D000h + 10 - 20	; HL' = VRAM݃AhX
	EXX
	LD	B, 25
	LD	A, (0D000h)	; ^C~O킹
				; \  :  uLO
				;  (<=165)  :	(<=63)
@5:
	LD	SP, IX		; 10 (10)
	POP	DE		; 10 (20)
	POP	HL		; 10 (30)
	EXX			;  4 (34)
	LD	A, L		;  4 (38)	; HL += 10
	ADD	A, 20		;  7 (45)
	LD	L, A		;  4 (49)
	ADC	A, H		;  4 (53)
	SUB	L		;  4 (57)
	LD	H, A		;  4 (61)
	POP	AF		; 10 (71)
	POP	BC		; 10 (81)
	POP	DE		; 10 (91)
	LD	SP, HL		;  6 (97)
	PUSH	DE		;  4 (101)   :	 7 ( 7)
	PUSH	BC		;		11 (18)
	PUSH	AF		;		11 (29)
	EXX			;		 4 (33)
	PUSH	HL		;		11 (44)
	PUSH	DE		;		11 (55)
	LD	DE, 10		;  2 (103)   :	 8 (63)
	ADD	IX, DE		; 15 (118)

	LD	SP, IX		; 10 (10)
	POP	DE		; 10 (20)
	POP	HL		; 10 (30)
	EXX			;  4 (34)
	LD	A, L		;  4 (38)	; HL += 10
	ADD	A, 10		;  7 (45)
	LD	L, A		;  4 (49)
	ADC	A, H		;  4 (53)
	SUB	L		;  4 (57)
	LD	H, A		;  4 (61)
	POP	AF		; 10 (71)
	POP	BC		; 10 (81)
	POP	DE		; 10 (91)
	LD	SP, HL		;  6 (97)
	PUSH	DE		;  4 (101)   :	 7 ( 7)
	PUSH	BC		;		11 (18)
	PUSH	AF		;		11 (29)
	EXX			;		 4 (33)
	PUSH	HL		;		11 (44)
	PUSH	DE		;		11 (55)
	LD	DE, 10		;  2 (103)   :	 8 (63)
	ADD	IX, DE		; 15 (118)

	LD	SP, IX		; 10 (10)
	POP	DE		; 10 (20)
	POP	HL		; 10 (30)
	EXX			;  4 (34)
	LD	A, L		;  4 (38)	; HL += 10
	ADD	A, 10		;  7 (45)
	LD	L, A		;  4 (49)
	ADC	A, H		;  4 (53)
	SUB	L		;  4 (57)
	LD	H, A		;  4 (61)
	POP	AF		; 10 (71)
	POP	BC		; 10 (81)
	POP	DE		; 10 (91)
	LD	SP, HL		;  6 (97)
	PUSH	DE		;  4 (101)   :	 7 ( 7)
	PUSH	BC		;		11 (18)
	PUSH	AF		;		11 (29)
	EXX			;		 4 (33)
	PUSH	HL		;		11 (44)
	PUSH	DE		;		11 (55)
	LD	DE, 20		;  2 (103)   :	 8 (63)
	ADD	IX, DE		; 15 (118)

	DJNZ	@5b		; 13 (131)

@7:	LD	SP, 0000h
	LD	A, (0CF42h)
	OR	A
	RET	Z
	EI
	RET

;============================================================================
;	pb`f[^
;============================================================================
PATCHDATA:	; AhX(W), (B), f[^(B)...

	;
	; t@C^[of
	;
	DW	0A556h
	DB	2
	DW	PUT_ORIG

	;
	; CLS[`
	;
	DW	0A698h
	DB	2
	DW	CLS_W

	;
	; WAIT[`
	;
	DW	0A6FFh
	DB	2
	DW	WAIT_W

	;
	; ̐
	;
	DW	0A762h
	DB	1
	DB	20h

	;
	; O̐ړ
	;
	DW	0A7A2h
	DB	1
	DB	20h

	;
	; t@C^[
	;
	DW	0A86Dh
	DB	1
	DB	20h

	;
	; r[
	;
	DW	0A9F5h
	DB	1
	DB	20h

	;
	; ZEPLIS
	;
	DW	0AC39h
	DB	1
	DB	20h

	;
	; Gp^[
	;
	DW	0ACEBh
	DB	1
	DB	20h

	;
	; SULPAG
	;
	DW	0AD84h
	DB	1
	DB	20h

	;
	; LOOPER
	;
	DW	0ADE0h
	DB	1
	DB	20h

	;
	; }Vq
	;
	DW	0AFD0h
	DB	1
	DB	22h

	;
	; PUT@[`
	;
	DW	0B0ABh
	DB	1
	DB	20h

	;
	; pb`f[^I
	;
	DW	0

	END
