;============================================================================
;	ZEPLIS3 ጸpb`
;============================================================================
	ORG	3000h

RDINF	EQU	0027h
RDDAT	EQU	002Ah
LDERR	EQU	00FEh
NL	EQU	0009h
LDMSG	EQU	013Eh
NAME	EQU	10F1h

WTVRAM	EQU	2000h		; zVRAM eLXg
WAVRAM	EQU	2800h		; zVRAM Agr[g

;
;	ZEPLIS3{̂[h
;
;;;CALL 09B3h
	CALL	RDINF
	JP	C, LDERR
	CALL	NL
	LD	DE, LDMSG	; 'LOADING'
	RST	18h
	LD	DE, NAME	; FILENAME
	RST	18h
	CALL	RDDAT
	JP	C, LDERR

;
;	pb`𓖂Ă
;
	LD	HL, PATCHDATA
@3:	LD	E, (HL)
	INC	HL
	LD	D, (HL)		; DE = pb`ăAhX
	LD	A, D
	OR	E
	JR	Z, @1f
	INC	HL
	LD	B, (HL)		; B = f[^̒
	INC	HL
@2:	LD	A, (HL)
	INC	HL
	LD	(DE), A
	INC	DE
	DJNZ	@2b
	JR	@3b
@1:

;
;	zʂ
;
	LD	HL, WTVRAM
	LD	DE, WTVRAM+1
	LD	BC, 1000
	LD	(HL), 0
	LDIR
	LD	HL, WAVRAM
	LD	DE, WAVRAM+1
	LD	BC, 1000
	LD	(HL), 70h
	LDIR

;
;	ZEPLIS3MZ-700[hŎs
;
	LD	HL, 0
	LD	(0CFF4h), HL
	LD	A, 22h
	JP	0A91Ah

;============================================================================
;	WAIT[ṽtbN[`
;	̍XVt[܂ő҂AzVRAMVRAMɓ]
;============================================================================
WAITLOOP_HOOK:
	;
	;	VBLNK̗҂
	;
	LD	HL, 0E002h	; 8255 |[gC
	XOR	A
@@:	OR	(HL)		; VBLNK=L̊ԃ[v
	JP	P, @b
@@:	AND	(HL)		; VBLNK=H̊ԃ[v
	JP	M, @b
	; fallthru
;============================================================================
;	zVRAMVRAM]
;	荞݋֎~ԂŌĂԂ
;	SWX^j
;============================================================================
VRAMtransfer:
	DI
	LD	(@7f+1), SP
	LD	HL, WTVRAM
	LD	(@5f+1), HL
	LD	HL, WAVRAM
	LD	(@6f+1), HL
	LD	IX, 0D000h + 10
	LD	IY, 0D800h + 10
	LD	BC, 11
	LD	A, (0D000h)	; ^C~O킹
	LD	A, 91		; (1000/11) = 90.9
				; \  :  uLO
@1:				;  (<=165)  :	(<=63)
	EX	AF, AF'		;'; 4 (4)
@5:	LD	SP, WTVRAM	; 10 (14)
	POP	DE		; 10 (24)
	POP	HL		; 10 (34)
	EXX			;  4 (38)
	POP	AF		; 10 (48)
	POP	BC		; 10 (58)
	POP	DE		; 10 (68)
	POP	HL		; 10 (78)
	DEC	SP		;  6 (84)
	LD	(@5b+1), SP	; 20 (104)
	LD	SP, IX		; 10 (114)
	LD	(IX), L		; 16 (130)  :	 3 ( 3)
	PUSH	DE		;		11 (14)
	PUSH	BC		;		11 (25)
	PUSH	AF		;		11 (36)
	EXX			;		 4 (40)
	PUSH	HL		;		11 (51)
	PUSH	DE		;		11 (62)
	ADD	IX, BC		; 15 (145)

@6:	LD	SP, WAVRAM	; 10 (10)
	POP	DE		; 10 (20)
	POP	HL		; 10 (30)
	EXX			;  4 (34)
	POP	AF		; 10 (44)
	POP	BC		; 10 (54)
	POP	DE		; 10 (64)
	POP	HL		; 10 (74)
	DEC	SP		;  6 (80)
	LD	(@6b+1), SP	; 20 (100)
	LD	SP, IY		; 10 (110)
	LD	(IY), L		; 16 (126)  :	 3 ( 3)
	PUSH	DE		;		11 (14)
	PUSH	BC		;		11 (25)
	PUSH	AF		;		11 (36)
	EXX			;		 4 (40)
	PUSH	HL		;		11 (51)
	PUSH	DE		;		11 (62)
	ADD	IY, BC		; 15 (141)

	EX	AF, AF'		;'; 4 (145)
	DEC	A		;  4 (149)
	JP	NZ, @1b		; 10 (159)

@7:	LD	SP, 0000h
	LD	A, (0CF76h)
	OR	A
	RET	Z
	EI
	RET

;============================================================================
;	(X,Y)VRAM
;============================================================================
XYtoVRAM:
	LD	L, C		; (X,Y)VRAM
	LD	C, B
	LD	B, 0
	LD	H, 0D0h
	SLA	C
	SLA	C
	SLA	C
	RL	B
	ADD	HL, BC
	SLA	C
	RL	B
	SLA	C
	RL	B
	ADD	HL, BC
	RET

;============================================================================
;	J[PUT@[` tbN
;============================================================================
PUTCHR_HOOK:
	CALL	0ABBCh
	JP	VRAMtransfer

PUTCHR_HOOK2:
	LD	A, 0D0h
	LD	(0ABFFh), A
	LD	A, 0D8h
	LD	(0AC03h), A
	CALL	0ABBCh
	LD	A, 20h
	LD	(0ABFFh), A
	LD	A, 28h
	LD	(0AC03h), A
	RET

;============================================================================
;	pb`f[^
;============================================================================
PATCHDATA:	; AhX(W), (B), f[^(B)...

	;
	; E̕\
	;
	DW	0A967h
	DB	1
	DB	28h

	DW	0A970h
	DB	1
	DB	20h

	DW	0A979h
	DB	1
	DB	21h

	;
	; ^Cg
	;
	DW	0A9E6h
	DB	1
	DB	28h

	DW	0A9E9h
	DB	1
	DB	28h

	DW	0AA07h
	DB	2
	DW	PUTCHR_HOOK

	;
	; ʃNA
	;
	DW	0AAE2h
	DB	1
	DB	20h

	;
	; WAIT[v tbN
	;
	DW	0AAF4h
	DB	3
	JP	WAITLOOP_HOOK

	;
	; (X,Y)VRAM
	;
	DW	0AB0Ch
	DB	1
	DB	20h

	;
	; J[PUT@[`
	;
	DW	0ABFFh
	DB	1
	DB	20h

	DW	0AC03h
	DB	1
	DB	28h

	;
	; _
	;
	DW	0B701h
	DB	1
	DB	21h

	DW	0B711h
	DB	1
	DB	21h

	DW	0B721h
	DB	1
	DB	21h

	DW	0B731h
	DB	1
	DB	21h

	DW	0B737h
	DB	1
	DB	21h

	DW	0B76Dh
	DB	1
	DB	21h

	DW	0B770h
	DB	1
	DB	21h

	DW	0B778h
	DB	1
	DB	21h

	;
	; GlM[Q[W\
	;
	DW	0B7DFh
	DB	1
	DB	20h

	DW	0B7ECh
	DB	1
	DB	23h

	;
	; t@C^[
	;
	DW	0B86Fh
	DB	2
	DW	XYtoVRAM

	DW	0B8ECh
	DB	2
	DW	PUTCHR_HOOK2

	;
	; c@\
	;
	DW	0B966h
	DB	1
	DB	23h

	;
	; p[AbvEp[c\
	;
	DW	0BA44h
	DB	1
	DB	22h

	;
	; NbV
	;
	DW	0BCEFh
	DB	2
	DW	XYtoVRAM

	;
	; pb`f[^I
	;
	DW	0

	END
