;============================================================================
;	ZELBUS ጸpb`
;============================================================================
	ORG	3000h

ATTR_MYSHIP	EQU	70h
ATTR_BLASTER	EQU	70h
ATTR_TARGET	EQU	20h
ATTR_BEAM	EQU	50h
ATTR_ENEMY	EQU	70h
ATTR_BAR	EQU	70h
ATTR_BULLET	EQU	70h
ATTR_BGMAP	EQU	40h
ATTR_MASHIRAHI	EQU	60h
ATTR_NAZO1	EQU	70h
ATTR_NAZO2	EQU	70h
ATTR_BIG	EQU	70h


RDINF	EQU	0027h
RDDAT	EQU	002Ah
LDERR	EQU	00FEh
NL	EQU	0009h
LDMSG	EQU	013Eh
NAME	EQU	10F1h

WTVRAM	EQU	2000h		; zVRAM eLXg (30x25)
WAVRAM	EQU	2800h		; zVRAM Agr[g (30x25)

;
;	ZELBUS{̂[h
;
;;;CALL 09B3h			; e[vւp L[͑҂
	CALL	RDINF
	JP	C, LDERR
	CALL	NL
	LD	DE, LDMSG	; 'LOADING'
	RST	18h
	LD	DE, NAME	; FILENAME
	RST	18h
	CALL	RDDAT
	JP	C, LDERR

;
;	pb`𓖂Ă
;
	LD	HL, PATCHDATA
@3:	LD	E, (HL)
	INC	HL
	LD	D, (HL)		; DE = pb`ăAhX
	LD	A, D
	OR	E
	JR	Z, @1f
	INC	HL
	LD	B, (HL)		; B = f[^̒
	INC	HL
@2:	LD	A, (HL)
	INC	HL
	LD	(DE), A
	INC	DE
	DJNZ	@2b
	JR	@3b
@1:

;
;	zʂ
;
	LD	HL, WTVRAM
	LD	DE, WTVRAM+1
	LD	BC, 750
	LD	(HL), 0
	LDIR
	LD	HL, WAVRAM
	LD	DE, WAVRAM+1
	LD	BC, 750
	LD	(HL), 70h
	LDIR

;
;	ZELBUSMZ-700[hŎs
;
	LD	A, 22h
	JP	9D14h

;============================================================================
;	PRINT tbN
;============================================================================
PrintHook:
	PUSH	DE
	LD	HL, (1171h)	; X, Y
	LD	B, L
	LD	A, H
	ADD	A, A		; Y*2
	ADD	A, A		; Y*4
	ADD	A, A		; Y*8
	LD	L, A
	ADD	A, B		; Y*8+X
	LD	C, A
	LD	H, 0D8h >> 2
	ADD	HL, HL		; (0D800h >> 1) + Y*16
	ADD	HL, HL		; 0D800h + Y*32
	LD	B, 0
	ADD	HL, BC		; 0D800h + Y*40 + X

@@:	LD	A, (DE)
	INC	DE
	CP	0Dh
	JR	Z, @f
	LD	(HL), 70h
	INC	HL
	JR	@b

@@:	POP	DE
	JP	0015h

;============================================================================
;	CLS tbN
;============================================================================
ClsHook:
	LD	HL, WTVRAM
	LD	DE, WTVRAM + 1
	LD	B, 0
	LD	A, 25
@@:	LD	C, 29
	LD	(HL), 0
	LDIR
	LD	C, 11
	ADD	HL, BC
	EX	DE, HL
	ADD	HL, BC
	EX	DE, HL
	DEC	A
	JR	NZ, @b

	LD	HL, WAVRAM
	LD	DE, WAVRAM + 1
	LD	A, 25
@@:	LD	C, 29
	LD	(HL), 70h
	LDIR
	LD	C, 11
	ADD	HL, BC
	EX	DE, HL
	ADD	HL, BC
	EX	DE, HL
	DEC	A
	JR	NZ, @b

	LD	HL, 0D000h
	LD	DE, 0D001h
	LD	A, 25
@@:	LD	C, 29
	LD	(HL), 0
	LDIR
	LD	C, 11
	ADD	HL, BC
	EX	DE, HL
	ADD	HL, BC
	EX	DE, HL
	DEC	A
	JR	NZ, @b

	LD	HL, 0D800h
	LD	DE, 0D801h
	LD	A, 25
@@:	LD	C, 29
	LD	(HL), 70h
	LDIR
	LD	C, 11
	ADD	HL, BC
	EX	DE, HL
	ADD	HL, BC
	EX	DE, HL
	DEC	A
	JR	NZ, @b

	RET

;============================================================================
;	ZELBUS̉zʂpb`̉zʂ֓]
;============================================================================
MAPTRANS_HOOK:
	LD	A, (0CF23h)
	LD	H, 0C9h
	LD	L, A
	LD	DE, WTVRAM
	LD	A, 25
@@:	LDI LDI LDI LDI LDI	; 5
	LDI LDI LDI LDI LDI	; 10
	LDI LDI LDI LDI LDI	; 15
	LDI LDI LDI LDI LDI	; 20
	LDI LDI LDI LDI LDI	; 25
	LDI LDI LDI LDI LDI	; 30
	LD	BC, 20
	ADD	HL, BC
	EX	DE, HL
	LD	C, 10
	ADD	HL, BC
	EX	DE, HL
	DEC	A
	JR	NZ, @b

	LD	HL, WAVRAM
	LD	DE, 10
	LD	C, 25
	LD	A, ATTR_BGMAP
@2:	LD	B, 3
@1:	LD	(HL), A		INC	HL
	LD	(HL), A		INC	HL
	LD	(HL), A		INC	HL
	LD	(HL), A		INC	HL
	LD	(HL), A		INC	HL
	LD	(HL), A		INC	HL
	LD	(HL), A		INC	HL
	LD	(HL), A		INC	HL
	LD	(HL), A		INC	HL
	LD	(HL), A		INC	HL
	DJNZ	@1b
	ADD	HL, DE
	DEC	C
	JR	NZ, @2b

	RET

;============================================================================
;	WAIT[ṽtbN[`
;	̍XVt[܂ő҂AzVRAMVRAMɓ]
;============================================================================
WAITLOOP_HOOK:
	;
	;	VBLNK̗҂
	;
	LD	HL, 0E002h	; 8255 |[gC
	XOR	A
@@:	OR	(HL)		; VBLNK=L̊ԃ[v
	JP	P, @b
@@:	AND	(HL)		; VBLNK=H̊ԃ[v
	JP	M, @b
	; fallthru
;============================================================================
;	zVRAMVRAM]
;	荞݋֎~ԂŌĂԂ
;	SWX^j
;============================================================================
VRAMtransfer:
	DI
	PUSH	BC
	LD	(@7f+1), SP
	LD	IX, WTVRAM		; IX  = zVRAMǂݍ݃AhX
	EXX
	LD	HL, 0D800h + 10 - 20	; HL' = VRAM݃AhX
	EXX
	LD	B, 25
	LD	A, (0D000h)	; ^C~O킹
				; \  :  uLO
				;  (<=165)  :	(<=63)
@5:
	LD	SP, IX		; 10 (10)
	POP	DE		; 10 (20)
	POP	HL		; 10 (30)
	EXX			;  4 (34)
	LD	BC, -800h+20	; 10 (44)		; ݃AhX Agr[geLXg, +20
	ADD	HL, BC		; 11 (55)
	POP	AF		; 10 (65)
	POP	BC		; 10 (75)
	POP	DE		; 10 (85)
	LD	SP, HL		;  6 (91)
	PUSH	DE		;  4 (95)    :	 7 ( 7)
	PUSH	BC		;		11 (18)
	PUSH	AF		;		11 (29)
	EXX			;		 4 (33)
	PUSH	HL		;		11 (44)
	PUSH	DE		;		11 (55)
	LD	DE, 800h	;  2 (97)    :	 8 (63)	; ǂݍ݃AhX eLXgAgr[g
	ADD	IX, DE		; 15 (112)

	LD	SP, IX		; 10 (10)
	POP	DE		; 10 (20)
	POP	HL		; 10 (30)
	EXX			;  4 (34)
	SET	3, H		;  8 (42)		; ݃AhX eLXgAgr[g
	POP	AF		; 10 (52)
	POP	BC		; 10 (62)
	POP	DE		; 10 (72)
	LD	SP, HL		;  6 (78)
	PUSH	DE		;  4 (82)    :	 7 ( 7)
	PUSH	BC		;		11 (18)
	PUSH	AF		;		11 (29)
	EXX			;		 4 (33)
	PUSH	HL		;		11 (44)
	PUSH	DE		;		11 (55)
	LD	DE, -800h+10	;  2 (84)    :	 8 (63)	; ǂݍ݃AhX Agr[geLXg, +10
	ADD	IX, DE		; 15 (99)

	LD	SP, IX		; 10 (10)
	POP	DE		; 10 (20)
	POP	HL		; 10 (30)
	EXX			;  4 (34)
	LD	BC, -800h+10	; 10 (44)		; ݃AhX Agr[geLXg, +10
	ADD	HL, BC		; 11 (55)
	POP	AF		; 10 (65)
	POP	BC		; 10 (75)
	POP	DE		; 10 (85)
	LD	SP, HL		;  6 (91)
	PUSH	DE		;  4 (95)    :	 7 ( 7)
	PUSH	BC		;		11 (18)
	PUSH	AF		;		11 (29)
	EXX			;		 4 (33)
	PUSH	HL		;		11 (44)
	PUSH	DE		;		11 (55)
	LD	DE, 800h	;  2 (97)    :	 8 (63)	; ǂݍ݃AhX eLXgAgr[g
	ADD	IX, DE		; 15 (112)

	LD	SP, IX		; 10 (10)
	POP	DE		; 10 (20)
	POP	HL		; 10 (30)
	EXX			;  4 (34)
	SET	3, H		;  8 (42)		; ݃AhX eLXgAgr[g
	POP	AF		; 10 (52)
	POP	BC		; 10 (62)
	POP	DE		; 10 (72)
	LD	SP, HL		;  6 (78)
	PUSH	DE		;  4 (82)    :	 7 ( 7)
	PUSH	BC		;		11 (18)
	PUSH	AF		;		11 (29)
	EXX			;		 4 (33)
	PUSH	HL		;		11 (44)
	PUSH	DE		;		11 (55)
	LD	DE, -800h+10	;  2 (84)    :	 8 (63)	; ǂݍ݃AhX Agr[geLXg, +10
	ADD	IX, DE		; 15 (99)

	LD	SP, IX		; 10 (10)
	POP	DE		; 10 (20)
	POP	HL		; 10 (30)
	EXX			;  4 (34)
	LD	BC, -800h+10	; 10 (44)		; ݃AhX Agr[geLXg, +10
	ADD	HL, BC		; 11 (55)
	POP	AF		; 10 (65)
	POP	BC		; 10 (75)
	POP	DE		; 10 (85)
	LD	SP, HL		;  6 (91)
	PUSH	DE		;  4 (95)    :	 7 ( 7)
	PUSH	BC		;		11 (18)
	PUSH	AF		;		11 (29)
	EXX			;		 4 (33)
	PUSH	HL		;		11 (44)
	PUSH	DE		;		11 (55)
	LD	DE, 800h	;  2 (97)    :	 8 (63)	; ǂݍ݃AhX eLXgAgr[g
	ADD	IX, DE		; 15 (112)

	LD	SP, IX		; 10 (10)
	POP	DE		; 10 (20)
	POP	HL		; 10 (30)
	EXX			;  4 (34)
	SET	3, H		;  8 (42)		; ݃AhX eLXgAgr[g
	POP	AF		; 10 (52)
	POP	BC		; 10 (62)
	POP	DE		; 10 (72)
	LD	SP, HL		;  6 (78)
	PUSH	DE		;  4 (82)    :	 7 ( 7)
	PUSH	BC		;		11 (18)
	PUSH	AF		;		11 (29)
	EXX			;		 4 (33)
	PUSH	HL		;		11 (44)
	PUSH	DE		;		11 (55)
	LD	DE, -800h+20	;  2 (84)    :	 8 (63)	; ǂݍ݃AhX Agr[geLXg, +20
	ADD	IX, DE		; 15 (99)

	DEC	B		;  4 (103)
	JP	NZ, @5b		; 10 (113)

@7:	LD	SP, 0000h
	POP	BC
	LD	A, (0CF7Dh)
	OR	A
	RET	Z
	EI
	RET

;============================================================================
;	(X,Y)WAVRAM
;============================================================================
XYtoWVRAM:
	LD	H, WAVRAM >> 8
	LD	L, C		; XW
	LD	C, B		; YW
	LD	B, 0
	SLA	C		; *2
	SLA	C		; *4
	SLA	C		; *8
	ADD	HL, BC
	SLA	C		; *16
	RL	B
	SLA	C		; *32
	RL	B
	ADD	HL, BC		; *40
	RET

;============================================================================
;	@\ tbN
;============================================================================
MyShipDisp:
	CALL	XYtoWVRAM
	PUSH	HL
	LD	A, ATTR_MYSHIP
	LD	(HL), A
	LD	BC, 39
	ADD	HL, BC
	LD	(HL), A
	INC	HL
	LD	(HL), A
	INC	HL
	LD	(HL), A
	DEC	C
	ADD	HL, BC
	LD	(HL), A
	INC	HL
	LD	(HL), A
	INC	HL
	LD	(HL), A
	POP	HL
	RES	3, H
	JP	0A06Fh

;============================================================================
;	Βn}VK\ tbN
;============================================================================
BlasterDisp:
	CALL	XYtoWVRAM
	LD	(HL), ATTR_BLASTER
	RES	3, H
	JP	0A3D5h

;============================================================================
;	en_\ tbN
;============================================================================
TargetDisp:
	CALL	XYtoWVRAM
	LD	(HL), ATTR_TARGET
	RES	3, H
	JP	0A489h

;============================================================================
;	r[\ tbN
;============================================================================
BeamDisp:
	CALL	XYtoWVRAM
	DEC	HL
	LD	(HL), ATTR_BEAM
	INC	HL
	INC	HL
	LD	(HL), ATTR_BEAM
	DEC	HL
	DEC	HL
	RES	3, H
	JP	0A583h

;============================================================================
;	???\ tbN
;============================================================================
BarDisp:
	CALL	XYtoWVRAM
	DEC	HL
	LD	(HL), ATTR_BAR
	INC	HL
	LD	(HL), ATTR_BAR
	INC	HL
	LD	(HL), ATTR_BAR
	DEC	HL
	DEC	HL
	RES	3, H
	JP	0A64Eh

;============================================================================
;	Ge\ tbN
;============================================================================
BulletDisp:
	CALL	XYtoWVRAM
	LD	(HL), ATTR_BULLET
	RES	3, H
	JP	0A86Eh

;============================================================================
;	G\ tbN
;============================================================================
EnemyDisp:
	CALL	XYtoWVRAM
	PUSH	IX
	PUSH	HL
	POP	IX
	LD	(IX+ 0), ATTR_ENEMY
	LD	(IX+ 1), ATTR_ENEMY
	LD	(IX+40), ATTR_ENEMY
	LD	(IX+41), ATTR_ENEMY
	POP	IX
	RES	3, H
	JP	0A9BAh

;============================================================================
;	}Vq\ tbN
;============================================================================
MashirahiDisp:
	CALL	XYtoWVRAM
	LD	(HL), ATTR_MASHIRAHI
	INC	HL
	LD	(HL), ATTR_MASHIRAHI
	DEC	HL
	RES	3, H
	JP	0AC46h

;============================================================================
;	???\ tbN
;============================================================================
Nazo1Disp:
	CALL	XYtoWVRAM
	LD	(HL), ATTR_NAZO1
	RES	3, H
	JP	0AEDAh

;============================================================================
;	???\ tbN
;============================================================================
Nazo2Disp:
	CALL	XYtoWVRAM
	PUSH	IX
	PUSH	HL
	POP	IX
	LD	(IX+ 0), ATTR_NAZO2
	LD	(IX+ 1), ATTR_NAZO2
	LD	(IX+40), ATTR_NAZO2
	LD	(IX+41), ATTR_NAZO2
	POP	IX
	RES	3, H
	JP	0A9BAh

;============================================================================
;	^Cgf tbN
;============================================================================
OpeningHook:
	CALL	WAITLOOP_HOOK
	JP	9E4Ah

;============================================================================
;	PUT@ tbN
;============================================================================
PutPatHook:
	PUSH	DE
	PUSH	HL
	PUSH	BC
	EXX			; 
	POP	BC		; B' = B, C' = C
	LD	HL, 40		; HL' = 40
	LD	C, B
	LD	B, 0		; BC' = B
	OR	A
	SBC	HL, BC		; HL' = 40 - B
	LD	B, H
	LD	C, L		; BC' = 40 - B
	POP	HL
	LD	A, H		; A = YW
	LD	H, WTVRAM >> 8	; VRAMAhX
	LD	DE, 40		; DE = 40
@@:	OR	A
	JR	Z, @f
	ADD	HL, DE		; HL' = 0D000h + Y*40 + X
	DEC	A
	JR	@b
@@:	POP	DE		; DE' = LN^f[^AhX
	EXX			; \
@2:
	PUSH	HL
	PUSH	BC
@1:
	LD	A, L		; XW
	CP	30		; 30 ?
	JR	NC, @4f
	LD	A, H		; YW
	CP	25		; 25 ?
	JR	NC, @4f
	EXX			; 
	LD	A, (DE)		; LN^f[^擾
	OR	A		; 󔒃LH
	JR	Z, @3f
	LD	(HL), A		; LN^
	SET	3, H
	LD	(HL), ATTR_BIG
	RES	3, H
@3:	EXX			; \
@4:	EXX			; 
	DEC	HL		; VRAM݃AhX--
	DEC	DE		; f[^AhX--
	EXX			; \
	DEC	L		; XW--
	DEC	B		; --
	JR	NZ, @1b		; Ԃ񃋁[v
	EXX			; 
	OR	A
	SBC	HL, BC		; ̍s
	EXX			; \
	POP	BC
	POP	HL
	DEC	H		; YW--
	RET	Z		; 0ȂI
	DEC	C		; c--
	RET	Z		; 0ȂI
	JR	@2b

;============================================================================
;	pb`f[^
;============================================================================
PATCHDATA:	; AhX(W), (B), f[^(B)...

	DW	9DE9h
	DB	2
	DW	WAITLOOP_HOOK

	DW	9E21h
	DB	2
	DW	OpeningHook

	DW	9EABh
	DB	2
	DW	WAITLOOP_HOOK

	DW	9F63h
	DB	2
	DW	WAITLOOP_HOOK

	DW	0A306h
	DB	3
	DB	0C3h
	DW	MAPTRANS_HOOK

	DW	0A315h
	DB	2
	DW	WTVRAM

	DW	0A06Ch
	DB	3
	DB	0C3h
	DW	MyShipDisp

	DW	0A486h
	DB	3
	DB	0C3h
	DW	TargetDisp

	DW	0A3D2h
	DB	3
	DB	0C3h
	DW	BlasterDisp

	DW	0A57Fh
	DB	3
	DB	0C3h
	DW	BeamDisp

	DW	0A6E4h
	DB	3
	DB	0C3h
	DW	PutPatHook

	DW	0A86Bh
	DB	3
	DB	0C3h
	DW	BarDisp

	DW	0A86Bh
	DB	3
	DB	0C3h
	DW	BulletDisp

	DW	0A9B7h
	DB	3
	DB	0C3h
	DW	EnemyDisp

	DW	0AC43h
	DB	3
	DB	0C3h
	DW	MashirahiDisp

	DW	0AED7h
	DB	3
	DB	0C3h
	DW	Nazo1Disp

	DW	0AF7Dh
	DB	3
	DB	0C3h
	DW	Nazo2Disp

	DW	9E2Dh
	DB	2
	DW	PrintHook

	DW	9E3Fh
	DB	2
	DW	PrintHook

	DW	9EF8h
	DB	2
	DW	PrintHook

	DW	0A1D8h
	DB	2
	DW	PrintHook

	DW	9E06h
	DB	2
	DW	ClsHook

	DW	0A1CCh
	DB	2
	DW	ClsHook

	DW	9EABh
	DB	2
	DW	WAITLOOP_HOOK

	DW	0A1BEh
	DB	2
	DW	WAITLOOP_HOOK

	DW	0

	END



